parser ParserImpl(packet_in packet, out headers hdr, inout metadata meta, inout standard_metadata_t standard_metadata) {

    @name(".parse_ipv4") state parse_ipv4 {
        packet.extract<ipv4_t>(hdr.ipv4);
        transition select(hdr.ipv4.fragOffset, hdr.ipv4.ihl, hdr.ipv4.protocol) {
            (13w0x0 &&& 13w0x0, 4w0x5 &&& 4w0xf, 8w0x11 &&& 8w0xff): parse_udp;
            // (13w0x0 &&& 13w0x0, 4w0x5, 8w0x6): parse_tcp;
            default: accept;
        }
    }
    
    @name(".parse_udp") state parse_udp {
        packet.extract<udp_t>(hdr.udp);
        transition select(hdr.udp.dstPort) {
            DISPATCHER_PORT: parse_map_hdr;
            16w9001: parse_map_hdr;
            16w9002: parse_map_hdr;
            16w9003: parse_map_hdr;
            16w9004: parse_map_hdr;
            16w9005: parse_map_hdr;
            16w9006: parse_map_hdr;
            16w9007: parse_map_hdr;
            SPEEDO_REPLY_PORT: parse_map_hdr;
            REPLY_PORT: parse_map_hdr;
            default: accept;
        }
    }

    // state parse_tcp {
    //     packet.extract(hdr.tcp);
    //     transition accept;
    // }

    @name(".parse_map_hdr") state parse_map_hdr {
        packet.extract(hdr.map_hdr);
        transition accept;
    }
    
    @name(".start") state start {
        packet.extract<ethernet_t>(hdr.ethernet);
        transition select(hdr.ethernet.etherType) {
            16w0x800: parse_ipv4;
            default: accept;
        }
    }
}